<?php
//include "smilepay_respond.php";
/**
 * Plugin Name: SmilePay_FamiPort
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay FamiPort
 * Author: SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 3.0.2
 */
if(!defined("SMILEPAY_RESPONSE_DECLARE"))
{
    include "smilepay_respond.php";
}
add_action('plugins_loaded', 'SmilePayfamiport_gateway_init', 0);
function SmilePayfamiport_gateway_init() {
   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }
    class WC_SmilePayfamiport extends WC_Payment_Gateway {
        public $title;
        public $description;
        public $dcvc;
        public $Rvg2c;
        public $Order_OKmain;
        public $Verify_key;

        public function __construct() {
            $this->id = 'smilepayfamiport';
            $this->icon = apply_filters('woocommerce_SmilePayfamiport_icon', plugins_url('log/famiport.jpg', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePayfamiport', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
            $this->Rvg2c =  $this->settings['Rvg2c'];
			$this->Deadline_date = $this->settings['Deadline_date'];
			$this->Order_OKmain = $this->settings['Order_OKmain'];
			//$this->reurl = $this->settings['reurl'];
            $this->reurl =get_option('siteurl')."/?smilepay_respond";
			$this->Verify_key = $this->settings['Verify_key'];
			$this->Mid_smilepay = $this->settings['Mid_smilepay'];
            // Actions
            //add_action('init', array(&$this, 'check_SmilePayfamiport_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_'.$this->id, array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
			//$urll=get_option('siteurl')."/?respond";
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2bf("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(u2bf('SmilePay aFamiPort'), 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2bf('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bf('UȦbbɩܪIڤ覡D'), 'woocommerce'),
                    'default' => __(u2bf('SmilePay aFamiPort úO'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2bf('Iڤ覡'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bf('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2bf("SmilePay aFamiPort úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2bf('ӮaN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bf('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Rvg2c' => array(
                    'title' => __(u2bf('ӮaѼƽX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bf('жJzSmilePayӮaѼƽX'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Verify_key' => array(
                    'title' => __(u2bf('ӮaˬdX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bf('жJzSmilePayӮaˬdXAˬdXӮaxuIAPIvAнƻsöKJW'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Mid_smilepay' => array(
                    'title' => __(u2bf('ӮaҰѼ'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bf('жJzSmilePaҽXAҽXӮaxu򥻸ƺ޲zvAнƻsöKJWApҽЫOdť'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
				'Deadline_date' => array(
                    'title' => __(u2bf('úںI'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bf('úںIAw]Ȭ7AжJ1~6Aoj7'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				'Order_OKmain' => array(
                    'title' => __(u2bf('U榨\ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bf('U榨\ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				/*'reurl' => array(
                    'title' => __(u2bf('^em'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bf('^emAбNUCrƻsWؤ(p^eЯdť)</br><font color=red ue size=+1>'.$urll.'</font>', 'woocommerce')),
                    'default' => __('', 'woocommerce')
                )*/
            );
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePayfamiport_args($order) {
            global $woocommerce;

            $paymethod = 'famiport';
            $order_id = $order->id;
			$post_status = $order->post_status;

            $SmilePayfamiport_args = array(
                "dcvc" => $this->dcvc,
                'Rvg2c' => $this->Rvg2c,
                "payment_type" => $paymethod,
                "od_sob" => $order_id,
				"post_status" => $post_status,
                'reurl' => $this->reurl,
                'Verify_key' => $this->Verify_key,
                'Mid_smilepay' => $this->Mid_smilepay,
				'Deadline_date' => $this->Deadline_date,
				'Order_OKmain' => $this->Order_OKmain,
				"amt" => round($order->get_total()),
            );
            $SmilePayfamiport_args = apply_filters('woocommerce_SmilePayfamiport_args', $SmilePayfamiport_args);
            return $SmilePayfamiport_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P   famiport
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
            // $order = &new WC_Order($order_id);
			$order = new WC_Order($order_id);
			
			
			
			$SmilePayfamiport_args = $this->get_SmilePayfamiport_args($order);
			$order_status=$SmilePayfamiport_args['post_status'];
		if($order_status=='wc-pending')
		{
	        //--ystart
			$shipping_method= $order->get_shipping_method();
			$getc2cu="N";
			if($_REQUEST['storeid']=='')
			{
				
                if(file_exists("smilepayc2cup.php"))
				    include_once("smilepayc2cup.php");
                if(class_exists('WC_Smilepayc2cu_Shipping_Method'))
                    $smilepay_c2cupobj= new WC_Smilepayc2cu_Shipping_Method();
                else
                    $smilepay_c2cupobj= null;

                //<b2c> start
                if(file_exists("smilepayb2cup.php"))
                    include_once("smilepayb2cup.php");
                if(class_exists('WC_Smilepayb2cu_Shipping_Method'))
                    $smilepay_b2cupobj = new WC_Smilepayb2cu_Shipping_Method();
                else
                    $smilepay_b2cupobj = null;
                //<b2c> end
                //ˬdyO_ϥί¨f
				if( $smilepay_c2cupobj && $smilepay_c2cupobj->isSelectedSmilepayC2Cup($order_id))
                {
					if(is_ssl())
                        $URL = 'https://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                    else
			            $URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                    //Mobile map start
                    $useragent=$_SERVER['HTTP_USER_AGENT'];
                    if( preg_match('/Android|iPad|iPhone/i',$useragent))
                    {
                            $mappurl="https://emap.presco.com.tw/c2cemapm-u.ashx?eshopid=870&servicetype=1&url=".urlencode($URL);
                          
                    }
                    if(!isset($mappurl))//Mobile map end
					    $mappurl="https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&url=".urlencode($URL);
					header("Location: $mappurl"); 
					exit();	
				}
                //<b2c> start
                elseif(  $smilepay_b2cupobj && $smilepay_b2cupobj->isSelectedSmilepayB2Cup($order_id))
                {


              
					if(is_ssl())
                        $URL = 'https://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                    else
			            $URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                    //Mobile map start
                    //if( !is_null(WC()->session->get('smilepay_711_c2c_shippingunpay_mobile_map')) && WC()->session->get('smilepay_711_c2c_shippingunpay_mobile_map') =='yes')
                    //{
                       $useragent=$_SERVER['HTTP_USER_AGENT'];
                        if( preg_match('/Android|iPad|iPhone/i',$useragent)  )
                        {
                            $mappurl="https://emap.presco.com.tw/emapmobileu.ashx?eshopid=870&servicetype=1&tempvar=b2c&url=".urlencode($URL);
                          
                        }
                        
                    //}
                   
                    if(!isset($mappurl))//Mobile map end
					    $mappurl="https://emap.presco.com.tw/emapu8.ashx?eshopid=870&servicetype=1&tempvar=b2c&url=".urlencode($URL);
                   
					header("Location: $mappurl"); 
					exit();	
				}
                //<b2c> end
			}
			else
			{
                //<b2c> start
                $b2c_run=false;
                if($_REQUEST['tempvar'] == 'b2c')
                {
                    $b2c_storeaddress=$_REQUEST['address'];
				    $b2c_storename=$_REQUEST['storename'];
				    $b2c_storeid=$_REQUEST['storeid'];
                    $b2c_run = true;
                } 
                //<b2c> end
                else 
                {
				    $c2c_storeaddress=$_REQUEST['storeaddress'];
				    $c2c_storename=$_REQUEST['storename'];
				    $c2c_storeid=$_REQUEST['storeid'];
                }
				$getc2cu="Y";			
			}
			//--yend

			if(is_numeric($SmilePayfamiport_args['Deadline_date'])&&$SmilePayfamiport_args['Deadline_date']<6)
			{$Deadline_date_value=$SmilePayfamiport_args['Deadline_date'];}
			else
			{$Deadline_date_value=6;}
			$Deadline_date = date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$Deadline_date_value,date("Y")));	
            //ھڷUվreurlOhttphttps
            if(is_ssl())
                $SmilePayfamiport_args['reurl']=str_replace('http://','https://',$SmilePayfamiport_args['reurl']);
            else
                $SmilePayfamiport_args['reurl']=str_replace('https://','http://',$SmilePayfamiport_args['reurl']);		
          	//
			if($SmilePayfamiport_args['reurl']!=''){$Vk=$SmilePayfamiport_args['reurl']."=".$order->get_order_key();}else{$Vk='';}
            $pur_name = $order->get_billing_last_name() . $order->get_billing_first_name();
		  	$smilepay_gateway = 'https://ssl.smse.com.tw/api/sppayment.asp';

            //<SmilePay>item add start
            /*$products="";
            foreach ($order->get_items() as $key => $lineItem) {
                $products .= $lineItem['name'] ."*" .$lineItem['item_meta']['_qty'][0] .",";
            
            }
            $products=trim($products,",");*/
            //<SmilePay>item add end

			$post_str = 'Dcvc=' . $SmilePayfamiport_args['dcvc'] .
					'&Rvg2c=' . $SmilePayfamiport_args['Rvg2c'] .
					'&Pur_name=' .$pur_name.
					'&Tel_number=' .$order->get_billing_phone().
                    '&Mobile_number=' .$order->get_billing_phone().
					'&Address=' .$order->get_billing_address_1().
					'&Email=' .$order->get_billing_email().
					'&Data_id=' . $SmilePayfamiport_args['od_sob'].
					'&od_sob=' . $SmilePayfamiport_args['od_sob'].
					'&Amount=' . $SmilePayfamiport_args['amt'].
					'&Deadline_date=' . $Deadline_date.
					'&Roturl_status=' . 'woook'.
					'&Verify_key=' . $SmilePayfamiport_args['Verify_key'].
                    '&Remark=woocommerce';
					 //<SmilePay>item add start
					//'&Remark='. $products;
                     //<SmilePay>item add end
			$post_strall=$post_str.'&Pay_zg=6'.'&Roturl=' . $Vk;
			
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
			curl_setopt($ch, CURLOPT_VERBOSE, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_strall);
			$string = curl_exec($ch);
			curl_close($ch);
			
			//gJƵ
			$xml = simplexml_load_string($string);
			$Status = $xml->Status;
			if(strpos($string,"<SmilePay>")&&$Status=="1")
			{
				//gJqúO-O
                $title = b2uf($this->title);
				$ordertext="úO覡G<font color=red>$title</font><br>úONXG<font color=red>".$xml->FamiNO."</font><br>úOG<font color=red>".$xml->PayEndDate."</font></br>pWLúOФúO</br>";
				$order->add_order_note(u2bf($ordertext),"1");	
				$ordertext="ФŧRTAtRtSmilePaylܽXG".$xml->SmilePayNO;
				$order->add_order_note(u2bf($ordertext),"0");
				//קq檬A	
				$order->update_status( 'on-hold' );	
				//ܤe
				echo u2bf("<font color='red' size='3'>`NGqwߡA|IڡAШúڸƺɳtI</font>");
				$showtext= "<br><br><h1>úOT</h1>úO覡G<font color='red' size='3'>$title</font></td></tr>";
				$showtext=$showtext."<br>úONXG<font color='red' size='3'>".$xml->FamiNO."</font>";
				$showtext=$showtext."<br>úOG<font color='red' size='3'>".$xml->PayEndDate."</font>";
				echo u2bf($showtext);
				echo u2bf("<br><font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
				echo "<br><br>".$SmilePayfamiport_args['Order_OKmain'];
				//--ystart
				if($getc2cu=="Y")
				{
                    if( $b2c_run) //<b2c> start 
                    {
                        include "smilepay_function_b2c.php";
					    $b2c_store=$b2c_storeid.'/'.$b2c_storename.'/'.$b2c_storeaddress;		
                        //<smilepay> modify address start 
                        if( !empty($b2c_storeid) && !empty($b2c_storename) && !empty($b2c_storeaddress))
                        {
                            $shipping_addr= $order->get_shipping_address_1();
                            $store_addr=$b2c_storeid ." " .$b2c_storename ." " .$b2c_storeaddress;
                            if($store_addr != $shipping_addr)
                            {
                             $order->set_shipping_address_1($store_addr);
                             $order->save();
                            }
                        }
                        //<smilepay> modify address end					
					    $scvurls=repeatb2c($b2c_store,$post_str,$SmilePayatm_args['dcvc'],$SmilePayatm_args['Verify_key']);
					    $order->add_order_note(u2bf($scvurls),"0");
					    $scvurls_1="7-11fG<font color=red>".b2uf($b2c_storename.$b2c_storeid)."</font><br>";
                        $scvurls_1 .= "a}G<font color=red>".b2uf($b2c_storeaddress)."</font><br>";
                        $scvurls_1 .= "fHmWG<font color=red>".b2uf($pur_name)."</font><br>";
                        $scvurls_1 .= "fHqܡG<font color=red>".b2uf($order->get_billing_phone())."</font><br>";
                        
                    }
                    else //<b2c> end
                    {
					    include "smilepay_function_c2c.php";
					    $c2c_store=$c2c_storeid.'/'.$c2c_storename.'/'.$c2c_storeaddress;
                        //<smilepay> modify address start 
                        if( !empty($c2c_storeid) && !empty($c2c_storename) && !empty($c2c_storeaddress))
                        {
                            $shipping_addr= $order->get_shipping_address_1();
                            $store_addr=$c2c_storeid ." " .$c2c_storename ." " .$c2c_storeaddress;
                            if($store_addr != $shipping_addr)
                            {
                             $order->set_shipping_address_1($store_addr);
                             $order->save();
                            }
                        }
                        //<smilepay> modify address end			
					    $scvurls=repeatc2c($c2c_store,$post_str,$SmilePayfamiport_args['dcvc'],$SmilePayfamiport_args['Verify_key']);
					    $order->add_order_note(u2bf($scvurls),"0");
					    $scvurls_1="7-11fG<font color=red>".b2uf($c2c_storename.$c2c_storeid)."</font><br>";
                        $scvurls_1 .= "a}G<font color=red>".b2uf($c2c_storeaddress)."</font><br>";
                        $scvurls_1 .= "fHmWG<font color=red>".b2uf($pur_name)."</font><br>";
                        $scvurls_1 .= "fHqܡG<font color=red>".b2uf($order->get_billing_phone())."</font><br>";
                       
                    }
					$order->add_order_note(u2bf($scvurls_1),"1");
					echo u2bf('<h1>fT</h1>' . $scvurls_1);
				}
				//--yend
				
				
			}
			else
			{
				if($Status!="")
				{	$ordererror="</br>~NXG".$xml->Status."</br>e]G".$xml->Desc."</br>OɶG".date("Y-m-d H:i:s",mktime(date(H)+8));	}
				else
				{	$ordererror="</br>e]Gsu`</br>OɶG".date("Y-m-d H:i:s",mktime(date(H)+8));	}
				$order->add_order_note(u2bf($ordererror),"1");
				$order->update_status( 'cancelled' );
                echo u2bf($ordererror);					
			}
		}
		else
		{
			echo u2bf("<font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
		}			


}
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
			$order = new WC_Order( $order_id );
            if(is_null($this->dcvc) || empty($this->dcvc) ||
               is_null($this->Verify_key) || empty($this->Verify_key) ||
               is_null($this->Rvg2c) || empty($this->Rvg2c)
                )
            {
                wc_add_notice(u2bf("<br>tRtӮaѼƿ~AлPӮapô<br>") , 'error' );
                return;
            }
			/*//--ystart
			$shipping_method= $order->get_shipping_method();
            if(file_exists('smilepayc2cp.php'))
			    include_once('smilepayc2cp.php');
            if(file_exists('smilepayc2cup.php'))
                include_once('smilepayc2cup.php');
            if( class_exists('WC_Smilepayc2cp_Shipping_Method'))
                $smilepayc2cp_obj=new WC_Smilepayc2cp_Shipping_Method();
            else
                $smilepayc2cp_obj= null;
            if( class_exists('WC_Smilepayc2cu_Shipping_Method'))
                $smilepayc2cup_obj=new WC_Smilepayc2cu_Shipping_Method();
            else
                $smilepayc2cup_obj= null;
            //<b2c> start
            if(file_exists('smilepayb2cp.php'))
                include_once('smilepayb2cp.php');
            if(file_exists('smilepayb2cup.php'))
                include_once('smilepayc2cup.php');
            if( class_exists('WC_Smilepayb2cp_Shipping_Method'))
                $smilepayb2cp_obj=new WC_Smilepayb2cp_Shipping_Method();
            else
                $smilepayb2cp_obj= null;
            if( class_exists('WC_Smilepayb2cu_Shipping_Method'))
                $smilepayb2cup_obj=new WC_Smilepayb2cu_Shipping_Method();
            else
                $smilepayb2cup_obj= null;
            //<b2c> end

            if( $smilepayc2cup_obj && $smilepayc2cup_obj->isSelectedSmilepayC2Cup($order_id))
            //if($shipping_method==u2bf("tRt7-11¨f"))
			{
				$username=$order->billing_first_name.$order->billing_last_name;
                if( !preg_match("/[^a-zA-Z0-9 ]/",$username))
                {
                    $limit_name_number =10;
                }
                else
                {
                    $limit_name_number =5;
                }
				if(substr($order->billing_phone,0,2)!="09"||mb_strlen($order->billing_phone)!=10||mb_strlen( $username, "utf-8")>$limit_name_number){
                    wc_add_notice( __(u2bf("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrA­^hiWL10ӦrCЦAT{C<br>"), 'woothemes') . $error_message, 'error' );
                    return;
					exit;
				}
			}
            if($smilepayc2cp_obj && $smilepayc2cp_obj->isSelectedSmilepayC2Cp($order_id))
			//if($shipping_method==u2bf("tRt7-11fI"))
			{
                wc_add_notice( __(u2bf("<br><font color='red'>te覡ܿ~Aiܦte覡</font><br>"), 'woothemes') . $error_message, 'error' );
                return;
                exit;
			}
            //<b2c> start
            if($smilepayb2cup_obj && $smilepayb2cup_obj->isSelectedSmilepayB2Cup($order_id))
			{
				$username=$order->billing_first_name.$order->billing_last_name;
                if( !preg_match("/[^a-zA-Z0-9 ]/",$username))
                {
                    $limit_name_number =10;
                }
                else
                {
                    $limit_name_number =5;
                }
				if(substr($order->billing_phone,0,2)!="09"||mb_strlen($order->billing_phone)!=10||mb_strlen( $username, "utf-8")>$limit_name_number){
                    wc_add_notice( __(u2bf("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrA­^hiWL10ӦrCЦAT{C<br>"), 'woothemes') . $error_message, 'error' );
                    return;
					exit;
				}


			}
            if($smilepayb2cp_obj && $smilepayb2cp_obj->isSelectedSmilepayB2Cp($order_id))		
			{
                wc_add_notice( __(u2bf("<br><font color='red'>te覡ܿ~Aiܦte覡</font><br>"), 'woothemes') . $error_message, 'error' );
                return;
                exit;
			}
            //<b2c> end
			//--yend*/
			//$order->reduce_order_stock();
            wc_reduce_stock_levels( $order_id );
			WC()->cart->empty_cart();
			return array(
				'result' 	=> 'success',
				'redirect'	=> $this->get_return_url( $order )
			);
        }

        /**
         * Payment form on checkout page
         *
         * @access public
         * @return void
         */

    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePayfamiport_gateway($methods) {
        $methods[] = 'WC_SmilePayfamiport';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'add_SmilePayfamiport_gateway');
}
function u2bf($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2uf($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
?>